<?php
		/**
		 *
		 * This is the CI config file
		 *
		 * @package    bizydads_hrmnew\config\config
		 * @version    1.0
		 * @copyright  2015, BizyCorp Internal Systems Development
		 * @license    private, All rights reserved
		 * @author     CI
		 * @uses
		 * @see
		 * @created
		 * @modified
		 * @modification
		 *
		 */

if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
|--------------------------------------------------------------------------
| File and Directory Modes
|--------------------------------------------------------------------------
|
| These prefs are used when checking and setting modes when working
| with the file system.  The defaults are fine on servers with proper
| security, but you may wish (or even need) to change the values in
| certain environments (Apache running a separate process for each
| user, PHP under CGI with Apache suEXEC, etc.).  Octal values should
| always be used to set the mode correctly.
|
*/
define('FILE_READ_MODE', 0644);
define('FILE_WRITE_MODE', 0666);
define('DIR_READ_MODE', 0755);
define('DIR_WRITE_MODE', 0777);

/*
|--------------------------------------------------------------------------
| File Stream Modes
|--------------------------------------------------------------------------
|
| These modes are used when working with fopen()/popen()
|
*/
define('FOPEN_READ',							'rb');
define('FOPEN_READ_WRITE',						'r+b');
define('FOPEN_WRITE_CREATE_DESTRUCTIVE',		'wb'); // truncates existing file data, use with care
define('FOPEN_READ_WRITE_CREATE_DESTRUCTIVE',	'w+b'); // truncates existing file data, use with care
define('FOPEN_WRITE_CREATE',					'ab');
define('FOPEN_READ_WRITE_CREATE',				'a+b');
define('FOPEN_WRITE_CREATE_STRICT',				'xb');
define('FOPEN_READ_WRITE_CREATE_STRICT',		'x+b');


if(ENVIRONMENT == 'production'){
	define('DHTMLX_LIB_URL','http://www.bizydads.com/frameworks/dhtmlx/');
	define('FRAMEWORKS_URL','http://www.bizydads.com/frameworks/');
	define('IMAGE_URL','http://www.bizydads.com/frameworks/images/');
	define('EKWA_COMMONLIB','http://www.bizydads.com/frameworks/ekwacommonlib/');
	define('UAACS_MOOD',true);
	
	//roles
	define('ADMIN',258);
	define('MANAGER',259);
	define('STAFF',261);
	
	//functions
	define('MANAGE_JOB_CREATE',590);
		define('MANAGE_JOB_DEFINITION',591);
		define('MANAGE_HIRING_STEPS',592);
			define('MANAGE_STEP_DEFFINITION',593);
			define('MANAGE_TEST_TYPE',594);
			define('MANAGE_TEST_QUESTIONS',595);
	
	define('MANAGE_APPLICANTS',596);
	define('MANAGE_INTERVIEW',597);
		define('MANAGE_INTERVIEW_PREPS',599);
		define('MANAGE_INTERVIEW_SCHEDULES',598);
		define('MANAGE_TESTS',600);
	
	define('TEST_EVL',603);//need key
	define('STAFF_REQUESTS',601);
	define('ACCESS_LOGS',602);
	
	define('STAFF_FEED','http://www.kindersigns.org/bizyoffice/index.php/');
	define('WORKTYPE_FEED','http://www.kindersigns.org/bizyoffice/index.php/work_types/index/');
	define('PROJECTS_FEED','http://www.kindersigns.org/bizyoffice/index.php/projects/index/true/0/0/data_feed_template/XML/0/0/0/1');
	define('JOBPROFILE_FEED','http://www.kindersigns.org/bizyoffice/index.php/jobprofile_controller/index/');
	
	define('STAFF_DROPDOWN','http://www.kindersigns.org/bizyoffice/index.php/staff/createDropdown');
	define('WORKTYPE_DROPDOWN','http://www.kindersigns.org/bizyoffice/index.php/work_types/createDropdown');
	define('PROJECTS_DROPDOWN','http://www.kindersigns.org/bizyoffice/index.php/projects/createDropdown');
	define('JOBPROFILE_DROPDOWN','http://www.kindersigns.org/bizyoffice/index.php/jobprofile_controller/createDropdown');
	
	define('UPLOADS_FOLDER_PATH','http://www.kindersigns.org/hrm30/public/uploads/');
}
else{
	define('DHTMLX_LIB_URL','http://www.bizydads.com/frameworks/dhtmlx/');
	define('FRAMEWORKS_URL','http://www.bizydads.com/frameworks/');
	define('IMAGE_URL','http://www.bizydads.com/frameworks/images/');
	define('EKWA_COMMONLIB','http://www.bizydads.com/frameworks/ekwacommonlib/');
	define('UAACS_MOOD',true);
	
	//roles
	define('ADMIN',304);
	define('MANAGER',305);
	define('STAFF',306);
	
	//functions
	define('MANAGE_JOB_CREATE',694);
		define('MANAGE_JOB_DEFINITION',627);
		define('MANAGE_HIRING_STEPS',695);
			define('MANAGE_STEP_DEFFINITION',696);
			define('MANAGE_TEST_TYPE',697);
			define('MANAGE_TEST_QUESTIONS',698);

	define('MANAGE_APPLICANTS',628);
	define('MANAGE_INTERVIEW',629);
		define('MANAGE_INTERVIEW_PREPS',662);
		define('MANAGE_INTERVIEW_SCHEDULES',661);
		define('MANAGE_TESTS',630);
		
	define('TEST_EVL',699);
	//define('MANAGE_STAFF_REQUESTS',663);
	//define('ADD_STAFF_REQUESTS',631);
	define('STAFF_REQUESTS',663);
	define('ACCESS_LOGS',693);
	
	
	define('STAFF_FEED','http://www.bizydads.com/bizyoffice/index.php/');
	define('WORKTYPE_FEED','http://www.bizydads.com/bizyoffice/index.php/work_types/index/');
	define('PROJECTS_FEED','http://www.bizydads.com/bizyoffice/index.php/projects/index/true/0/0/data_feed_template/XML/0/0/0/1');
	define('JOBPROFILE_FEED','http://www.bizydads.com/bizyoffice/index.php/jobprofile_controller/index/');
	
	define('STAFF_DROPDOWN','http://www.bizydads.com/bizyoffice/index.php/staff/createDropdown');
	define('WORKTYPE_DROPDOWN','http://bizydads.com/bizyoffice/index.php/work_types/createDropdown');
	define('PROJECTS_DROPDOWN','http://www.bizydads.com/bizyoffice/index.php/projects/createDropdown');
	define('JOBPROFILE_DROPDOWN','http://www.bizydads.com/bizyoffice/index.php/jobprofile_controller/createDropdown');
	
	define('UPLOADS_FOLDER_PATH','http://bizydads.com/roshan/hrm_2.0/public/uploads/');
}

/*
 * mail config settings
 */
if(ENVIRONMENT == 'testing'){
	define('EMAIL_SEND',false);
	define('TEST_EMAIL','nuwan@ekwa.com');
	define('PDA_EMAIL','pda@ekwa.com');
	define('SYSTEMUSER','325');
}
else if(ENVIRONMENT == 'qa'){
	define('EMAIL_SEND',false);
	define('TEST_EMAIL','nadeeka@ekwa.com');
	define('PDA_EMAIL','pda@ekwa.com');
	define('SYSTEMUSER','325');
}
else if(ENVIRONMENT == 'production'){
	define('EMAIL_SEND',true);
	define('TEST_EMAIL','nuwan@ekwa.com');
	define('PDA_EMAIL','pda@ekwa.com');
	define('SYSTEMUSER','325');
}
else{
	define('EMAIL_SEND',false);
	define('TEST_EMAIL','nuwan@ekwa.com');
	define('PDA_EMAIL','pda@ekwa.com');
	define('SYSTEMUSER','325');
}

/*
 |--------------------------------------------------------------------------
 | AIR app setting
 |--------------------------------------------------------------------------
 | Define AIR URL, integration ids, link app ids, function ids
*/
if(ENVIRONMENT == 'testing' || ENVIRONMENT == 'qa'){
	define('AR_URL', 'http://bizydads.com/appqa/AI/AI/index.php/appregistrar/'); //AIR url
	define('SYSTEM_USER', 692); //common variables
	
	//link app ids
	define('HRM_ID', 147);
	define('TS_ID', 99);

	//integration ids
	define('TMS_POSTING', 91);//TMS and HRM, AIR id

	//calling app function ids
	define('JOB_DEFINITIONS', 627);
}
else{//need to update variable values
	define('AR_URL', 'http://bizydads.com/appqa/AI/AI/index.php/appregistrar/'); //AIR url
	define('SYSTEM_USER', 692); //common variables
	
	//link app ids
	define('TS_ID', 99);

	//integration ids
	define('TMS_POSTING', 81);//TMS and HRM, AIR id

	//calling app function ids
	define('JOB_DEFINITIONS', 627);
}

/* End of file constants.php */
/* Location: ./application/config/constants.php */
