<?php
/**
 * @package    HRM\controller\interview_schedules
 * @version    1.0
 * @copyright  2016, BizyCorp Internal Systems Development
 * @license    private, All rights reserved
 * @author     CIGen (Automated CI Code Generator)
 */

if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * This file contains CI controller for CI Code Generation
 * 
 * 
 * This class contains the following functions
 *
 *  1) function index() , can be used to retrieve data from the table with filteration
 *	2) function save() , can be used to add / update data
 *	3) function key_validate() , used to validate the primary key of the table
 *	4) function delete() , used to delete a record
 *	5) function loadForm(), used to load the forms
 *	6) public function createDropdown(), generates the dropdown
 *	7) function loadWB(), initiates the workbench
 *
 * @package      HRM\controller\interview_schedules
 * @version		 1.0
 * @uses			
 * @see				
 * @copyright	 2016, BizyCorp Internal Systems Development
 * @license		 private, All rights reserved
 * @author		 CIGen (Automated CI Code Generator)
 * @created    	Mar 25, 2016
 * @modified   	Mar 25, 2016
 * @modification 
 */
class Interview_Schedules extends CI_Controller{
	/**
	 * Common vars
	 * User post_id
	 * @var $user_name
	 */
	private $user_name='';	
	
	/**
	 * Common vars
	 * User Type
	 * @var $user_type
	 */
	private $user_type='';
	
	/**
	 * Common vars
	 * Log Object instance
	 * @var $log_create
	 */
	private $log_create='';
	
	/**
	 * Function __construct
	 *
	 * The constructor function
	 * 
	 * @param	None
	 * @return	void
	 * @access	
	 * @since	1.0
	 */
    function __construct(){
    	parent::__construct();
    	
    	//for test purpose store session manuall till dev is completed
    	if($_SESSION){
    		$this->user_name=$_SESSION["user_name"];
    		$this->user_type=$_SESSION["user_type"];
    	}else{
    		$this->user_name='';
    		$this->user_type='';
    	}
    	
    	$this->log_create = new log_object();
    	$this->log_create->set_disable($this->config->item('log_status'));
    	$this->log_create->set_userDetails($this->user_name, $this->user_type);
    	
    	$this->load->model('interview_schedules_model');
    	$this->load->model('Job_applications_model');
    	$this->load->model('interview_definition_model');
    	$this->load->model('Google_Calendar_model');
    	$this->load->model('Hire_Steps_model');
    }//end of construct__
	
	
	/**
	 * Function set_external_session_vars()
	 *
	 * This method is be executed for extra function definitions to be implemented when AIR token verification
	 * is done.
	 * This function is executed by AIR_Utilities class upon successfull token verification
	 *
	 * @param	None
	 * @return	void
	 * @access	public
	 * @since	1.0
	 */
	
	public function set_external_session_vars(){
	
		// You can specify custome session variables soon after AIR call and token is verified.
		// By default after token verification, necessessary UAACS session vars get initiated inside AR_Utilities class. 
		// This method can be used to initiate additional session vars if needed
		
		// example usage
		// $_SESSION['Test_Session_1'] = 'This is a test session';
		
	}//end of set_txternal_session_vars();
	
		
		/**
		 * Function index()
		 *
		 * @param $search, Boolean value whether search is enable or not
		 * @param $limit, Limit of record set
		 * @param $offset, Offset of record set
		 * @param $file , view file
		 * @param $format , format of the out put
		 * @param $collist, to pass the column filter to the view columns are sent as
		 *        col01:col02:...:coln and is pased to view as an array of col post_ids
		 *        (Added by WCD on 31/7/13)
		 * @param $widths to pass the column widths to the view, widths are sent as col1=10:col2=25.... to the controller
		 * 		  controller will pass the width as array to the view
		 * 		  array('col1'=>10,'col2'=>25)
		 * @param $visibilityList, pass the visibility list to the view, list should be sent col1=true:col2=false ... to the controller 
		 * 		  and the contorller will process the param and construct an array as 
		 *        array(col1=>true,col2=>true,col3=>false)) and pass it to the view
	     * @param $cellStyles, pass the cell styles list to the view, list should be sent text-align:center_text-align:center_text-align:left ... to the controller 
	     * 		  and the contorller will process the param and construct an array as 
	     *        array(text-align:center,text-align:center,text-align:center) and pass it to the view
	     *        
		 * Data from view :
		 * Use $_REQUEST
		 * Filed post_ids are like :  filed_post_id_querymethod
		 *
		 *	Send to Model : Array of data
		 * ex: Array('search' => $searchobj_array,'limit' => $limit,'offset'=>$offset)
		 *
		 * Note : $searchobj_array is a array consist of set of objects.
		 * ex: $searchobj_array = array([0]=>array('search_filed'=>'post_id','search_text'=>'sara','query_method'=>'like'),[1]=>array('search_filed'=>'country','search_text'=>'srilanka','query_method'=>'equel'))
		 * @return  the data feed
		 * @access	public
	 	 * @since	1.0
		 */
      
	function index($search=FALSE,$limit=0,$offset=0,$file='data_feed_template',$format='',$collist='',$widths='',$visibilityList='',$cellStyles=''){	
		$this->log_create->set_otherDetails(array('Mode'=>'view','Data'=>'QUERY- STRING:'.count($_POST)>0?serialize($_POST):serialize($_GET)));
		$this->log_create->init();
		
		if($search==true){
			$searchobj_array = array();
			
			foreach((count($_POST)>0?$_POST:$_GET) as $key => $val){
				$search_text=$val; //search text
				$pos = strrpos($key, '_');
				$query_method = substr($key,$pos+1);
				$field= substr($key, 0, $pos);
				
				//if filed has '.'
				$field = str_replace('/','.',$field);
				
				//log_message('info',"\$field :- $field");
				$search_obj= array('search_field' => $field, 'search_text' => $search_text,'query_method'=>$query_method);
				array_push($searchobj_array, $search_obj);
			}
			$data['dataset'] = $this->interview_schedules_model->get_data(array('search'=>$searchobj_array,'limit' => $limit,'offset'=>$offset,'order_by'=>array('interview_schedules.IS_id'=>'Asc')));
		}
		else{
			$data['dataset'] = $this->interview_schedules_model->get_data(array('limit' => $limit,'offset'=>$offset,'order_by'=>array('interview_schedules.IS_id'=>'Asc')));
		}
		
		$wrapped_data['data'] = $data;
		$wrapped_data['format'] = $format;
		$wrapped_data['searchOn'] = $search;
		
		$wrapped_data['collist'] = $collist ? explode(':',$collist) : array('IS_id','designation','first_name','last_name','staff_id','type','status');
		
		if($widths !="0" && $widths !=""){
			$widthsPara = explode(':',$widths);
			foreach ($widthsPara as $val ){
				$split =  explode('=',$val);
				$widths_arr[$split[0]]= $split[1];
			}
		}
		$wrapped_data['widths'] = $widths ? $widths_arr : array(
			'IS_id'=>75,
            'designation'=>200, 
            'first_name'=>100,
            'last_name' =>100,          		
            'staff_id'=>200,
            'type'=>100,
            'status'=>100
		);
		
		if($visibilityList !="0" && $visibilityList !=""){
			$visibilityListPara = explode(':',$visibilityList);
			foreach ($visibilityListPara as $val){
				$split =  explode('=',$val);
				$visibilityList_arr[$split[0]]= $split[1];
			}
		}
		$wrapped_data['visibilityList'] = $visibilityList ? $visibilityList_arr : array(
			'IS_id'=>true,
		    'designation'=>true,	
		    'first_name' => true,
		    'last_name'	 => true,   		 
		    'staff_id'=>true,
		    'type'=>true,
		    'status'=>true,
		);
		
		if($cellStyles !="0" && $cellStyles !=""){
			$stylesListPara = explode('_',$cellStyles);
			foreach ($stylesListPara as $val ){
				$stylesList_arr[]= $val;
			}
		}
		$wrapped_data['cellStyles'] = $cellStyles ? $stylesList_arr : array(
			'text-align:center',
		    'text-align:left',
		    'text-align:left',
		    'text-align:left',
		    'text-align:left',
		    'text-align:left',
		    'text-align:left'
		);
		
		//manual pagination related code
		$wrapped_data['data']['dataset']['limit'] = $limit;
		$wrapped_data['data']['dataset']['offset'] = $offset;
		
		$this->load->view($file,$wrapped_data);
	}//end of index method
	
	
	/**
	 * Function data_form 
	 * 
	 * function handaling form add,edit,delete and view features
	 * 
	 * @param  $data stirng values, key
	 * @param  $mode strign, forms type add, edit, delete, view
	 * @return	
	 * @access	
	 * @since	1.0
	 */
	
	function data_form($mode='add',$data = null){
		$debug = false;
		$this->output->enable_profiler($debug);
		
		$event_id = null;
		$msg = null;
		$calendarId = 'g4gdq6d2ttjqd28acjiqe410l0@group.calendar.google.com';
		
		$this->log_create->set_otherDetails(array('Mode'=>$mode?$mode:'-','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data:'-')));
		$this->log_create->init();
		
		$data2save = array();
		$key2save = array();
		$message = array('msgText'=>'','msgType'=>'','focusField'=>'');
		$attendees = array();
		
		//get applicant list based on status SHORTLISTED,1STINTERVIEWDONE,2NDINTERVIEWDONE,3RDINTERVIEWDONE,
		// 1STTESTGIVEN,1STTESTEVALUATED,2NDTESTGIVEN,2NDTESTEVALUATED,3RDTESTGIVEN,3RDTESTEVALUATED
		if($mode != 'add'){
			$app_list_row = $this->Job_applications_model->get_data(array(
				'search'=>array(
					array('search_field' => 'job_applications.status','search_text' => 'SHORTLISTED','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => 'INTERVIEW SCHEDULED','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => 'TEST SEND','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => 'TEST GIVEN','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => '2NDINTERVIEWDONE','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => '3RDINTERVIEWDONE','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => '1STTESTEVALUATED','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => '2NDTESTEVALUATED','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => '3RDTESTEVALUATED','query_method'=>'orlike'),
				), 'limit' => 0, 'offset'=>0
			));
		}
		else{
			$app_list_row = $this->Job_applications_model->get_data(array(
				'search'=>array(
					array('search_field' => 'job_applications.status','search_text' => 'SHORTLISTED','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => 'EVALUATION DONE','query_method'=>'orlike'),
					array('search_field' => 'job_applications.status','search_text' => 'INTERVIEW DONE','query_method'=>'orlike'),
				), 'limit' => 0, 'offset'=>0
			));
		}
		
		$app_list = $app_list_row['result_set'];
		$wrapper['app_list'] = $app_list;
		
		if($mode != 'add' && $data!=null){
			$limit = 1;
			$offset = 0;
			$row = $this->interview_schedules_model->get_data(array(
		 		'search'=>array(
		 			array('search_field'=>'event_id', 'search_text'=>$data, 'query_method'=>'equal'),
		 			array('search_field'=>'interview_schedules.status', 'search_text'=>"pending", 'query_method'=>'equal')
		 		),
				'limit' => $limit, 'offset'=>$offset
			));
			if(isset($row['result_set'][1])){
		 		$w = $row['result_set'][1];
		 		foreach ($w as $c=>$v){ $wrapper[$c] = $v; }
			}else{
				$wrapper['error'] = "No Schedules..!";
			}
		 }//end if
		 $postData = $this->input->post(null);
		 
		 if(!empty($postData)){
		 	//set up summary
		 	if($mode=='edit'){
			 	if($postData['type'] == 'interview'){
			 		$postData['summary'] = 	$postData['summary'] .' - (Interview)';
			 	}
			 	else if($postData['type'] == 'Test'){
			 		$postData['summary'] = 	$postData['summary'] .' - (Examination)';
			 	}//end if type test
		 	}
		 	
		 	// setup attendees. usually applicant would be by default an attendee for an event.
		 	//get applicant details
		 	$app_id = $postData["app_id"];
		 	$app_data_ressult = $this->Job_applications_model->get_data(
		 		array(
		 			'search'=>array(array('search_field' => 'job_applications.id','search_text' => $app_id,'query_method'=> 'equal')),
		 			'limit' => 1, 'offset'=>0, 'order_by'=>array('job_applications.id'=>'Asc')
		 		)
		 	);
		 	
		 	$app_full_name = $app_data_ressult['result_set'][1]['first_name'].' '.$app_data_ressult['result_set'][1]['last_name'];
		 	$app_email = $app_data_ressult['result_set'][1]['email'];
		 	$app_post_id = $app_data_ressult['result_set'][1]['post_id'];
		 	
		 	if($debug){
		 		$attendees[] = array('display_name'=>'App Name:'.$app_full_name.'|App email:'.$app_email, 'email'=> emailcon('nuwan@ekwa.com'));
		 		$postData["description"] = $postData["description"]." - Debug: ".'App Name:'.$app_full_name.'|App email:'.emailcon($app_email);
		 	}
		 	else{
		 		$attendees[] = array('display_name'=>$app_full_name, 'email'=>emailcon($app_email));
		 	}
		 	
		 	//staff would be an attendee if the event type is an interview
		 	if($postData['type'] == 'interview' && !empty($postData['staff_id'])) {
		 		//get staff email id
		 		$staff_info = get_staff_info_array($postData['staff_id']);
		 		if($debug){
		 			$attendees[] = array('displayName'=>'Staff Name:'.$staff_info['full_name'].'|Staff email:'.$staff_info['office_email'], 'email'=>emailcon('nuwan@ekwa.com'));
		 			$postData["description"] = $postData["description"]." - Debug: ".'Staff Name:'.$staff_info['full_name'].'|Staff email:'.$staff_info['office_email'];
		 		}
		 		else{
		 			$attendees[] = array('displayName'=>$staff_info['full_name'], 'email'=>emailcon($staff_info['office_email']));
		 		}
		 	}//end if staff info
		 	$postData['attendees'] = $attendees;
		}//end if post data
		
		switch ($mode){
			case "add": //-----------------------------------------------------
				//Check duplicates
				
				if(!empty($postData)){
					$calendar_responce = $this->Google_Calendar_model->add_event($postData);
					$event_id = $calendar_responce->getId();
					
					//if htmlLink is set which means the event has been added to calendar successfully
					if (isset($calendar_responce->htmlLink)) {
						if($postData['type'] == 'interview'){ $data2save['staff_id'] = $postData['staff_id']; }
						else{ $data2save['staff_id'] = 0; }
						
						$data2save['type'] 		= $postData['type'];
						$data2save['app_id'] 	= $postData['app_id'];
						$data2save['scheduled_datetime'] = $postData['start_date'];
						$data2save['status'] 	= 'pending';
						$data2save['event_id'] 	= $event_id;
						$data2save['post_id'] 	= $app_post_id;
						$data2save['test_id'] 	= (!empty($postData['test_id']))?$postData['test_id']:0;
						$data2save['ID_id'] 	= $postData['ID_id'];
						$data2save['ID_step'] 	= $postData['ID_step'];
						$result = $this->interview_schedules_model->save($data2save,$key2save);
						
						//updating application status to interview schedul status
						$app_status = get_contents_with_session(site_url().'/job_applications/update_status/interview_scheduled/'.$postData['app_id']);
						
						$message['msgText'] 	= '<span style="color:#008000;">Event successfully created!</span>';
						$message['msgType'] 	= 'success';
						$message['gridHandler'] = 'updateAndClose';
					}
					else{
						$message['msgText'] 	= 'Could not create the event';
						$message['msgType'] 	= 'failure';
						$message['focusField'] 	= 'type';
					}
				}//end if post
			break;
			case "edit":
				$event_id 	= $data;
				$event_data = $this->Google_Calendar_model->get_event($calendarId,$event_id);
				$st_date_parts = explode('+',$event_data['start']['dateTime']);
				$en_date_parts = explode('+',$event_data['end']['dateTime']);
				
				$wrapper['event_id'] 	= $event_id;
				$wrapper['start_date'] 	= $st_date_parts[0];
				$wrapper['end_date'] 	= $en_date_parts[0];
				$wrapper['summary'] 	= $event_data['summary'];
				$wrapper['description'] = $event_data['description'];
				
				//Do validations if form submitted based on POST var
				if (!empty($postData)) {
					//$event_id = $data;
					//$calendar_responce = $this->Google_Calendar_model->update_event($calendarId , $event_id,$postData);
					//$key2save = array('event_id',$event_id);
					//$msg = $this->interview_schedules_model->save($data2save,$key2save);
					//if ($msg) {
					// 	$message['msgText'] ='<span style="color:#008000;">Record successfully updated!</span>';
					//	$message['msgType'] ='success';
					//	essage['gridHandler'] ='updateAndClose';
					//}else{
					//	$message['msgText'] =$msg;
					//	$message['msgType'] ='failure';
					//	$message['focusField'] ='post_id';
					//}
				}
				//end validation & save
			break;
			case "update":
				//Do validations if form submitted based on POST var
				if (!empty($postData)) {
					$event_id = $postData['event_id'];
					$calendar_responce = $this->Google_Calendar_model->update_event($calendarId , $event_id,$postData);
					$key2save = array('event_id'=>$event_id);
					
					$data2save['staff_id'] 	= isset($postData['staff_id'])?$postData['staff_id']:'';
					$data2save['type'] 		= $postData['type'];
					$data2save['app_id'] 	= $postData['app_id'];
					$data2save['scheduled_datetime'] = $postData['start_date'];
					$data2save['status'] 	= 'pending';
					$data2save['event_id'] 	= $event_id;
					$data2save['post_id'] 	= $app_post_id;
					
					$msg = $this->interview_schedules_model->save($data2save,$key2save);
					if ($msg) {
						$message['msgText'] ='<span style="color:#008000;">Event successfully updated..!</span>';
						$message['msgType'] ='success';
						//essage['gridHandler'] ='updateAndClose';
					}
					else{
						$message['msgText'] = $msg;
						$message['msgType'] = 'failure';
						$message['focusField'] = 'post_id';
					}
				}//end if postdata
			break;
			case "delete":
				//just diplay delete form with event info
				$event_id 	= $data;
				$event_data = $this->Google_Calendar_model->get_event($calendarId,$event_id);
				
				$st_date_parts = explode('+',$event_data['start']['dateTime']);
				$en_date_parts = explode('+',$event_data['end']['dateTime']);
				
				$wrapper['event_id']	= $event_id;
				$wrapper['start_date']	= $st_date_parts[0];
				$wrapper['end_date'] 	= $en_date_parts[0];
				$wrapper['summary'] 	= $event_data['summary'];
				$wrapper['description'] = $event_data['description'];
			break;
		}//end switch
		
		//$wrapper = $postData;
		$wrapper['message'] = $message;
		$wrapper['mode'] 	= $mode;
		$this->load->view('interview_schedule_form',$wrapper);
	}//end of function
	
	
	public function get_app_post_inter_def_details($app_id){
		//get app data, post_data, interview def data for a given applicant
		$app_data_ressult = $this->Job_applications_model->get_data(
			array(
				'search'=>array(array('search_field' => 'job_applications.id','search_text' => $app_id,'query_method'=> 'equal')),
				'limit'=>1, 'offset'=>0, 'order_by'=>array('job_applications.id'=>'Desc')
			)
		);
		
		$app_full_name = $app_data_ressult['result_set'][1]['first_name'].' '.$app_data_ressult['result_set'][1]['last_name'];
		$app_status = $app_data_ressult['result_set'][1]['status'];
		$post_id = $app_data_ressult['result_set'][1]['post_id'];
		
		$int_def_data_ressult = $this->interview_definition_model->get_data(
			array(
				'search'=>array(array('search_field'=>'post_id', 'search_text'=>$post_id, 'query_method'=>'equal')),
				'limit'=>1, 'offset'=>0, 'order_by'=>array('ID_id'=>'Desc')
			)
		);
		
		if(!empty($int_def_data_ressult['result_set'])){
			//fetch how many hiring processes has been through this applicant
			$ID_id = $int_def_data_ressult['result_set'][1]['ID_id'];
			$hire_steps_ressult = $this->Hire_Steps_model->get_data(
				array(
					'search'=>array(
						array('search_field' => 'app_id','search_text' => $app_id,'query_method'=> 'equal'),
						array('search_field' => 'post_id','search_text' => $post_id,'query_method'=> 'equal'),
						array('search_field' => 'ID_id','search_text' => $ID_id,'query_method'=> 'equal'),
					), 'limit' => 0, 'offset'=> 0
				)
			);
			$previous_steps = count($hire_steps_ressult['result_set']);
			
			$int_def_data_ressult['result_set']['app_full_name'] = $app_full_name;
			$int_def_data_ressult['result_set']['app_status'] = $app_status;
			$int_def_data_ressult['result_set']['no_of_previous_steps'] = $previous_steps;
			$int_def_data_ressult['result_set']['duration'] = "";
			
			$test = objectToArray(json_decode($int_def_data_ressult['result_set'][1]['definition']));
			if(isset($test[$previous_steps+1]['type']) && $test[$previous_steps+1]['type']=="test"){
				$this->load->model('interview_test_model');
				$interview_test = $this->interview_test_model->get_data(
					array(
						'search'=>array(array('search_field'=>'IT_id', 'search_text'=>$test[$previous_steps+1]['test_id'], 'query_method'=>'equal')),
						'limit'=>0, 'offset'=>0
					)
				);
				$interview_test = $interview_test['result_set'][1];
				$int_def_data_ressult['result_set']['duration'] = $interview_test['duration'];
			}
			
			$int_def_json = json_encode($int_def_data_ressult['result_set']);
			echo $int_def_json;
		}//end if
	}//end of function
	
	
	public function select_event($mode='edit'){
		$calendarId = 'g4gdq6d2ttjqd28acjiqe410l0@group.calendar.google.com';
		$events  = $this->Google_Calendar_model->list_events( $calendarId, false, false, 10000 );
		
		$wrapper['events'] = $events;
		$wrapper['message'] = null;
		$wrapper['mode'] = $mode;
		$this->load->view('event_selector',$wrapper);
	}//end function
	
	    	
	/**
  	 * Function save()
  	 * 
  	 * Data from View
  	 * using $_REQUEST
  	 * Data to model
  	 * send data as a array
  	 * two arrays. One is for data and one is for key.
  	 * ex: data=array('field1'=>'value1','field2'=>'value2'.....);
  	 *     key=array('staff_id'=>123,'project_id'=>534);
  	 *     
  	 * @param   action - add or edit
  	 * @param   callback - callback fun post_id for field validation
  	 * @return  bool true/false
  	 * @access	
	 * @since	2.0
  	 */
  	function save($action,$callback = null){
  		$save_data=array();
  		$key=array();
  		$metadata = $this->interview_schedules_model->getMetadata();
  		$metadata = explode(",",$metadata['PK']);
  		
  		log_message('info','Save data :-'.serialize($_POST));
  		
  		foreach((count($_POST)>0?$_POST:$_GET) as $k => $v){
  			$end = substr(strrchr($k, "_"), 1);
  			if(in_array($k,$metadata) !== false){
  				$key[$k] = $v;
  			}
  			elseif($end=='skip'){
  				//nothing do with skip
  			}
  			else{
  				$save_data[$k]=$v;
  			}
  		}
  		
		$added=$this->interview_schedules_model->save($save_data,$key);
		$this->log_create->set_otherDetails(array('Mode'=>$action,'Data'=>serialize($save_data).", KEY: ".serialize($key)));
		$this->log_create->init();  				
		echo $added;  	
	}//end of save method
	
	
	public function show_calendar(){
		$data=array();
		$this->load->view('show_calendar',$data);
	}//end of function
	
	
    /**
	 * Function key_validate()
	 *
	 * This is to validate the keys which are send based on the action param
	 * key=array('staff_id'=>123,'project_id'=>534,'worktype_id'=>342);
	 *
	 * @param $action , add / edit
	 * @param $key , primary $key can be composit or single
	 *
	 * @return true on success or on valid key , on inexistance or invalid key error will be returned as an array
	 * 		ex: array('primary_key'=>'Doesnt exists','staff_id'=>'Doesnt exists')
	 *
	 * @access
	 * @since	2.0
	 */
	
    function key_validate($action,$key) {
    	//make overall validation true at the begining
	    $overall_valid=true;
	    $error_info=array();
	    
	    /*check for the primary key or composite key exists. Send key array to check.*/
	    $key_exist=$this->interview_schedules_model->exists($key);
		
	    if($key_exist) {
	    	if($action=='add') {
	    		//if the primary key exists this can not add. so validation fails and add information
	    		//to error info array.
	    		$overall_valid=false;
	    		$error_info['primary_key']='Record Already exists';
	    	}
	    	if($action=='edit') {
	    		//in edit function the primary key should be there.
	    		//to error info array.
	    		$overall_valid=true;
	    	}
	    }
	    else{
	    	if($action=='add') {
	    		//if primary key not found it can be added
	    		$overall_valid=true;
	    	}
	    	if($action=='edit') {
	    		//if primary key not found it can not be edited
	    		$overall_valid=false;
	    		$error_info['primary_key']='Record Doesnt exists';
	    	}
	    }
	     
	    if($overall_valid==true){
	        return true;
	    }
	    else  {
	        return $error_info; //array('primary_key'=>'Already exists') or
	                            //array('primary_key'=>'Doesnt exists','staff_id'=>'Doesnt exists')  
	    }
    }
	
		
	/**
	 * Function delete()
	 * 
	 * Data from View
	 * using $_REQUEST
	 * $_REQUEST['staff_id']=234
	 *
	 * @param $String, the key 
	 *  
	 * Data to model
	 * send a array
	 * ex: $key = array('staff_id'=>123,'project_id'=>245,'worktype_id'=>933)
	 * 
	 * @return 
     * @access	
     * @since	2.0
	 */
	function delete($event_id){
		$calendarId = 'g4gdq6d2ttjqd28acjiqe410l0@group.calendar.google.com';
		$gresponse = $this->Google_Calendar_model->delete_event($calendarId,$event_id);
		
		$this->log_create->set_otherDetails(array('Mode'=>'delete','Data'=>'event deleted - id:'.$event_id));
		$this->log_create->init();
		
		$this->interview_schedules_model->delete($delete);
		return $gresponse;
	}//end of function


	function deleteall(){
		$calendarId = 'g4gdq6d2ttjqd28acjiqe410l0@group.calendar.google.com';
		$events  = $this->Google_Calendar_model->list_events( $calendarId, "2016-02-01", false, 10000 );
		
		foreach ($events as $key=>$value){
			$gresponse[] = $this->Google_Calendar_model->delete_event($calendarId,$value['id']);
		}
		echo"<pre>";print_r($gresponse);echo"</pre>";
	}
	

	/**
	* Function loadForm()
	* 
	* load the form for creation / edit
	* 
	* @param $editable, key, mode info
	* @param $file , post_id of the view file
	* @return 
	* @access	
	* @since	2.0
	*/ 
  	function loadForm($editable=null,$file='interview_definition_form') {
  		$data['editable'] = $editable;
  		$this->load->view($file,$data);
  	} 

	
	 /**
	  * Function loadWB()
	  * 
	  * function initiates the workbech
	  *
	  * @param $file , post_id of the view file
	  * @return loads the work bench
      * @access	
      * @since	2.0
	  */
 	function loadWB($file='interview_schedules_wb'){
 		$data ='';
 		$this->load->view($file,$data);
 	}
	
  	
	    /**
 		 * Function createDropdown()
 		 *
 		 * 
 		 * Function overview :-
 		 * createDropdown is the component function. 
 		 * Its main functionality is to produce a dropdown with pre populated table data
 		 *
 		 * Parameter list :-
 		 *
 		 *   $data['displayClm']     => 'field1'  - preselection of column to be displayed         //sachini
 		 *   $data['selectByValue']  => null      - preselection of list items by value
 		 *   $data['selectBYText']   => null      - preselection of list items by Text
 		 *   $data['filterBy']       => null      - filter data set by a field or list
 		 *   $data['outFormat']      => 'html'    - Format of the output like HTML,XML Etc
 		 *   $data['isMultiple']     => false     - is the drop down with multi select capable
 		 *   $data['sort']           => 'asc'     - sort list text Ascending or Descending
 		 *   $data['optionsOnly']    => false     - Specify the controller that output only <options> values
 		 *   $data['groupBy']        => null      - Display the dropdown grouped according to the specified column        //sachini
 		 *   $data['post_idTag']        => 'field2'  - post_id and Id values of the select tag                                 //sachini
 		 *
 		 *
 		 *    Usage :-
 		 *
 		 *    1) Format for internal functional call by passing data array
 		 *    $data = array('selectByValue' => null,
 		 *					'selectBYText' => null,
 		 *					'outFormat' => 'html' ,
 		 *					'isMultiple' => false,
 		 *					'sort' => 'asc',
 		 *					'optionsOnly' => false,
 		 *					'filterBy' => array(
 		 *									'search_field' => 'T.status',
 		 *									'search_text' => '0',
 		 *									'query_method'=>'equal',
 		 *									'order_by' => 'asc'
 		 *									)
 		 *						)
 		 *
 		 *    2) Format of external call by URL
 		 *    http://.../index.php/Interviewers/createDropdown/?sbv=null&sbt=null&format=html&multiple=false&sort=asc&filterby=status_equal=1
 		 *
 		 *    1. For normal listing:
 		 *    http://.../index.php/Interviewers/createDropdown
 		 *
 		 *    2. For listing with multiple selection
 		 *    http://.../index.php/Interviewers/createDropdown/?multiple=true
 		 *
 		 *    3. For listing with pre selection (select by value) for single selection drop down
 		 *    http://.../index.php/Interviewers/createDropdown/?sbv=123
 		 *
 		 *    4. For listing with pre selection for multiple (select by value)
 		 *    http://.../index.php/Interviewers/createDropdown/?sbv=123,321,345&multiple=true
 		 *
 		 *    5. For listing with pre selection of select by text for single selection dropdown
 		 *     http://.../index.php/Interviewers/createDropdown/?sbt=test string&multiple=true
 		 *
 		 *    6. For xml(DHTMLX compatible) dropdown
 		 *    http://.../index.php/Interviewers/createDropdown/?format=xml
 		 *
 		 *    7. groupBy
 		 *    http://...../Interviewers/createDropdown/?groupby=users.user_type
 		 *
 		 *	 8. groupCode
 		 *	  http://..../Interviewers/createDropdown/?groupby=users.user_type&groupcodes=1=Staff,2=Admin,4=Manager
 		 *
 		 *    Description of parameter list,
 		 *    sbv - selectByValue  => null
 		 *    sbt - selectBYText   => null
 		 *    format - outFormat   => 'html'
 		 *    multiple - isMultiple=> false
 		 *    sort - sort          => 'asc'
 		 *    filterby - filterBy  => null
 		 *    optionsOnly - options only listing
 		 *
 		 *    groupBy - column to group, should be specified with the table post_id ex: interviewers.staff_id
 		 *	  groupcodes - coma seperated values to display as group lable
 		 *
		 * @param $data , data array
		 * @access public
		 * @return returns the table dropdown
		 * @since 1.0
 		 */
	public function createDropdown($data = false){
	  	$dataset = null;
	  	$selectByValue = null;
	  	$selectBYText = null;
	  	$outFormat = 'html' ;
	  	$isMultiple = null;
	  	$sort = null;
	    $sort_array = array('interviewers.IS_id' => 'DESC');
	  	$filterBy = null;
	   	$searchobj_array = null;
	   	$optionsOnly = false;
	   	$label = null;
	   	$displayClm = 'interviewers.updated_by';
	   	$groupBy = null;   
	   	$groupcodes = null;
	   	$post_idTag = 'IS_id'; 
	  	
	  	/**
	  	 *	first check whether the call is internal(ie:internal function call) or external(ie:url call)
	  	 *	to do this we can check $data variable.if this variable is an array it means its an internal call
	  	 *	if $data is 'false' it means its an external call.
	  	 */	
	  	if(is_array($data)){
	  		
	  		/** 
	  		 * this is an internal call. so construct the search obj with passed array parameeters. 
	  		 * extract the data and pass on to the view
	  		 */
	  		$selectByValue = isset($data['selectByValue'])?$data['selectByValue']:null;
	  		$selectBYText = isset($data['selectBYText'])?$data['selectBYText']:null;
	  		$outFormat = isset($data['outFormat'])?$data['outFormat']:null;
	  		$isMultiple = isset($data['isMultiple'])?$data['isMultiple']:false;
	  		$sort = isset($data['sort'])?$data['sort']:'interviewers.IS_id=ASC';
	  		$filterBy = isset($data['filterBy'])?$data['filterBy']:null;
	  		$optionsOnly = isset($data['optionsOnly'])?$data['optionsOnly']:false;
	  		
	  		$label = isset($data['label'])?$data['label']:'IS_id';
	  		$displayClm = isset($data['display'])?$data['display']:$displayClm;
	  		$groupBy = isset($data['groupBy'])?$data['groupBy']:null;    
	  		$post_idTag = isset($data['post_idTag'])?$data['post_idTag']:'IS_id';    
	  		$groupcodes = isset($data['groupcodes'])?$data['groupcodes']:null;
	  	}
	  	else{
	  		/** 
	  		 * this is an external url call. So process $_GET or $_POST parameeter values and using
	  		 * these values construct search obj and fetch data for combo box
	  		 */
	  		if(count($_POST)>0 || count($_GET)>0){
	  			
	        	$myParams = count($_POST)>0? $_POST:$_GET;
	  
	  			$selectByValue = isset($myParams['sbv'])? $myParams['sbv']:null ;		
	  			$selectByValue = (!empty($selectByValue))?$selectByValue:null; // set default values if not supplied.
	  			 		
	  			$selectBYText = isset($myParams['sbt'])?$myParams['sbt']:null;
	  			$selectBYText = (!empty($selectBYText))?$selectBYText:null;
	  			
	  			$outFormat = isset($myParams['format'])?$myParams['format']:null;
	  			$outFormat = ($outFormat != 'html' && !empty($outFormat))?$outFormat:'html';
	  			
	  			$isMultiple = isset($myParams['multiple'])?$myParams['multiple']:null;
	  			$isMultiple = ($isMultiple == 'true')?true:false;
	  			
	  			$sort = isset($myParams['sort'])?$myParams['sort']:'interviewers.IS_id=ASC';
	  			
	  			$filterBy_string = isset($myParams['filterby'])? $myParams['filterby']:null;
	  			$filterBy_string = (!empty($filterBy_string))?$filterBy_string:null;
	  			
	  			$optionsOnly = isset($myParams['optionsonly'])? $myParams['optionsonly']:false;
	  			$optionsOnly = ($optionsOnly == 'true')? true:false;
	  
	  			$label = isset($myParams['label'])?$myParams['label']:null;
	  			$label = (!empty($label))?$label:null;
	  			
	  			$displayClm = isset($myParams['display'])? $myParams['display']:$displayClm;
	  			$displayClm = (!empty($displayClm))?$displayClm:'description';
	  			
	  			$groupBy = isset($myParams['groupby'])?$myParams['groupby']:null;    
	  			$groupBy = (!empty($groupBy))?$groupBy:null;                         
	  			
	  			$groupcodes = isset($myParams['groupcodes'])?$myParams['groupcodes']:null;
	  			
	  			/**
	  			 *	first check whether the request includes grouping
	  			 *	to do this we can check $groupBy variable.if this variable is null then it is ungrouped dropdown
	  			 *	if $groupBy is 'field1' it means its a request for grouped dropdown.
	  			 */
	  			if($groupBy){
	  				
	  				/**
	  				 * this is a grouped dropdown request
	  				 * set the $sort_array first sorted according to $groupBy column and then to $displayClm
	  				 */
	  				$sort_array = array($groupBy => 'ASC',$displayClm => 'ASC' );
	  				if (!empty($groupcodes)){
	  					$sortPara = explode(',',$groupcodes);
	  					foreach ($sortPara as $val ){
	  						$split =  explode('=',$val);
	  						$group[$split[0]]= $split[1];
	  					}
	  				}
	  			}else{
	  				/**
	  				 * this is not a grouped dropdown request
	  				 */
	  				$sort = isset($myParams['sort'])?$myParams['sort']:"$displayClm=ASC";
	  			}
	  			//end of sort allocation condition
	  			
	  			$post_idTag = isset($myParams['post_idtag'])?$myParams['post_idtag']:$post_idTag;   
	  			$post_idTag = (!empty($post_idTag))?$post_idTag:'IS_id';                       
	  			if(!empty($filterBy_string)){        
	  				$fieldPara = explode(',',$filterBy_string);
	          		foreach ($fieldPara as $val )   {
             			$split =  explode('=',$val);
             			$filterBy[$split[0]]= $split[1];
          			}
	  			}else{
	  				$filterBy = null;
	  			}
	        
	        	if (!empty($sort)){
	        		$sortPara = explode(',',$sort);
	        		foreach ($sortPara as $val )   {
	        			$split =  explode('=',$val);
	        			$sort_array[$split[0]]= $split[1];
	          		}
	        	}
	  		}
	  	}//end of param check and config
	  	// Construct search object if present 
	  		
	  	If ($filterBy){
	  		$searchobj_array = array();
	  		
	  		foreach($filterBy as $key => $val){
	  			$search_text = $val; //search text
	  			$query_method = substr(strrchr($key, "_"), 1);
	  			$pos = strrpos($key, '_');
	  			$field = substr($key, 0, $pos);
	  			$search_obj = array(
  					'search_field' => $field,
  					'search_text'  => $search_text,
  					'query_method' => $query_method
	  			);
	  			array_push($searchobj_array, $search_obj);
	  		}	
	  	}//end if
	    
      //Construct selection list. (Fixed)
      $selection = 'interviewers.IS_id,interviewers.IS_id,interviewers.job_def_id,interviewers.staff_id,interviewers.details,interviewers.date_added,interviewers.added_by,interviewers.date_updated,interviewers.updated_by';
    
      // Fetch data from model
  	  $dataset = $this->interview_schedules_model->get_data(array(
		'search' => $searchobj_array,
  		'limit' => 0,
  		'offset'=>0,
		'selection' => $selection,
    	'order_by' => $sort_array
  	  ));  
	  	
	  	// Construct data structure for view
	  	$wrapped_data['data']['dataset'] = $dataset;	
	    $wrapped_data['selectByValue'] = $selectByValue;
	  	$wrapped_data['selectByText'] = $selectBYText;
	  	$wrapped_data['outFormat'] = $outFormat;
	  	$wrapped_data['isMultiple'] = $isMultiple;
	  	$wrapped_data['required'] = true;
		$wrapped_data['label'] = $label;
		
		$displayClm =  explode('.',$displayClm);
		$wrapped_data['display'] = $displayClm[1];
		$wrapped_data['post_idTag'] = $post_idTag;
	  	
	  	if($optionsOnly !=""){
	  		$wrapped_data['optionsOnly'] = $optionsOnly;
	  	}
	  	
	  	if($groupBy != ""){
	  		$gb_arrya=explode(",",$groupBy);
	  		for($x=0;$x<count($gb_arrya); $x++){
	  			$gb = explode(".",$gb_arrya[$x]);
	  			$wrapped_data['groupBy'] = $gb[1];
	  		}    
	  	}
	  	   
	  	if(!empty($group)){
	  		$wrapped_data['codepost_id'] = $group;
	  	}
  		
	  	$this->load->view('dropdown_template',$wrapped_data);	  		
    }// End of Function createDropdown
}//-------- END CLASS -------------------------------------------------------
?>
