<?php
		/**
		 * This controller facilitates the access of table profiles
		 *
		 * @package    HRM\controller\profiles
		 * @version    1.0
		 * @copyright  2016, BizyCorp Internal Systems Development
		 * @license    private, All rights reserved
		 * @author     CIGen (Automated CI Code Generator)
		 */
		
		if ( ! defined('BASEPATH')) exit('No direct script access allowed');
		
		/**
		 * This file contains CI controller for CI Code Generation
		 * 
		 * 
		 * This class contains the following functions
		 *
		 *  1) function index() , can be used to retrieve data from the table with filteration
		 *	2) function save() , can be used to add / update data
		 *	3) function key_validate() , used to validate the primary key of the table
		 *	4) function delete() , used to delete a record
		 *	5) function loadForm(), used to load the forms
		 *	6) public function createDropdown(), generates the dropdown
		 *	7) function loadWB(), initiates the workbench
		 *
		 * @package      HRM\controller\profiles
		 * @version		 1.0
		 * @uses			
		 * @see				
		 * @copyright	 2016, BizyCorp Internal Systems Development
		 * @license		 private, All rights reserved
		 * @author		 CIGen (Automated CI Code Generator)
		 * @created    	Mar 25, 2016
		 * @modified   	Mar 25, 2016
		 * @modification 
		 */
class Profiles extends CI_Controller{
	
	/**
	 * AIR related vars
	 * Default request method
	 * @var $request_method
	 */
	private $request_method = 'get'; 

	/**
	 * AIR related vars
	 * This is reffering to the token which is received from calling app.
	 * @var $received_token
	 */
	private $received_token = null;  
	
	/**
	 * AIR related vars
	 * Default This is reffering to the token whic is generated and obtained from AIR directly
	 * @var $token
	 */
	private $token 			= null; 

	/**
	 * AIR related vars
	 * $AIR_call_flag
	 * @var $AIR_call_flag
	 */
	private $AIR_call_flag 	= false;
	
	/**
	 * AIR related vars
	 * debug
	 * @var $debug
	 */
	private $debug 			= true;  
	
	/**
	 * AIR related vars
	 * AR_Utilities
	 * @var $AR_Utilities
	 */
	private $AR_Utilities 	= null;

	/**
	 * Common vars
	 * User Name
	 * @var $user_name
	 */
	private $user_name='';	
	
	/**
	 * Common vars
	 * User Type
	 * @var $user_type
	 */
	private $user_type='';
	
	/**
	 * Common vars
	 * Log Object instance
	 * @var $log_create
	 */
	private $log_create='';
	
	/**
	 * Function __construct
	 *
	 * The constructor function
	 * 
	 * @param	None
	 * @return	void
	 * @access	
	 * @since	1.0
	 */
 
    function __construct(){
       	parent::__construct();
        if(!empty($_SESSION["user_name"]) && !empty($_SESSION["user_type"])){
        	$this->user_name=$_SESSION["user_name"];
        	$this->user_type=$_SESSION["user_type"];
        }else{
        	$this->user_name='';
        	$this->user_type='';
        }
        
        $this->log_create = new log_object();
        $this->log_create->set_disable($this->config->item('log_status'));
        $this->log_create->set_userDetails($this->user_name, $this->user_type);
        
        /* Init AIR Lib===========================================================
         * 
         * check http request method. If its 'get' then output/error messasges can be echoed directly.
         * if http request method is 'post' then AR_Utilities class header method should be implemented
         * 
         */
        if(isset($_GET['token']) && !empty($_GET['token'])){
        	$this->received_token = $_GET['token'];
        	$this->request_method = 'get';
        }else if(isset($_POST['token']) && !empty($_POST['token'])){
        	$this->received_token = $_POST['token'];
        	$this->request_method = 'post';
        }else if(isset($_GET['token']) && empty($_GET['token'])){
        	$this->received_token = null;
        	$this->request_method = 'get';
        	
        	//if the request is get type then echo the error code and err msg directly
        	echo "Error : 511 Token was not given!<br>";
        	exit;
        }else if(isset($_POST['token']) && empty($_POST['token'])){
        	$this->received_token = null;
        	$this->request_method = 'post';
        	
        	//if the request is post type then use header output
        	$this->header_output(511,'Token was not given!!');
        	exit;
        }
        
        if(!empty($this->received_token)){
        	// Load AR_Utilities library only if an external call is made on this controller.
        	$this->load->library('AR_Utilities');
        	$this->AR_Utilities = new AR_Utilities("called_app",$this->received_token,$this->request_method);
        	if($this->AR_Utilities->validityStatus['validity'] == 'VALID'){
        		$this->AIR_call_flag = true;
        	}
        }//end if        	
        //==================================================================================
        
        $this->load->model('job_applications_model');
        $this->load->model('Job_definitions_model');
        $this->load->model('staff_requests_model');
        $this->load->model('profiles_model');
        $this->load->library('email');
	}//end of construct__
	
	
	function check_login(){
		@session_start();
		if(!empty($_SESSION['user_name']) && !empty($_SESSION['user_type']) ){
        	return true;
        }else{
        	return false;          	        	
        }//end if
	}//end if
	
	public function logout(){
		unset($_SESSION['user_name']);
		unset($_SESSION['user_type']);
		unset($_SESSION['profile_user_email']);
		unset($_SESSION['pid']);
		header('Location: '.site_url('profiles').'/');
	}//end of function
	
	
	public function login(){
		$wrapper['msg'][] = array('type' => null, 'msg' => null);
		$login_data = $this->input->post(null,true);
		
		if(!empty($login_data['email']) && !empty($login_data['password'])){
			$email = $login_data['email'];
			$password = md5($login_data['password']);
			$result = $this->profiles_model->get_data(
				array(
					'search'=>array( 
						array('search_field' => 'email', 'search_text' => $email, 'query_method'=>'equal'),
						array('search_field' => 'password', 'search_text' => $password, 'query_method'=>'equal')
					),
					'limit' => 1, 'offset'=> 0, 'order_by'=>array('profiles.pid'=>'Asc')
				)
			);
			
			if(!empty($result['result_set'])){
				$_SESSION['user_name'] = $result['result_set'][1]['first_name'];
				$_SESSION['user_type'] = 'profile_user';
				$_SESSION['profile_user_email'] = $result['result_set'][1]['email'];
				$_SESSION['pid'] = $result['result_set'][1]['pid'];
				$this->index();
			}else{
				$wrapper['msg'][] = array('type' => 'error', 'msg' => "User Not Found! Please check your email id or password and re-login");
				$this->load->view('login',$wrapper);
			}//end if
		}else{
			$this->load->view('login',$wrapper);
		}	
	}//end of function
	
		
	/**
	 * Function set_external_session_vars()
	 *
	 * This method is be executed for extra function definitions to be implemented when AIR token verification
	 * is done.
	 * This function is executed by AIR_Utilities class upon successfull token verification
	 *
	 * @param	None
	 * @return	void
	 * @access	public
	 * @since	1.0
	 */
	
	public function set_external_session_vars(){
	
		// You can specify custome session variables soon after AIR call and token is verified.
		// By default after token verification, necessessary UAACS session vars get initiated inside AR_Utilities class. 
		// This method can be used to initiate additional session vars if needed
		
		// example usage
		// $_SESSION['Test_Session_1'] = 'This is a test session';
	}//end of set_txternal_session_vars();
	
	
	function array_insert (&$array, $position, $insert_array) {
		$first_array = array_splice ($array, 0, $position);
		$array = array_merge ($first_array, $insert_array, $array);
	}
	
		/**
		 * Function index()
		 *
		 * @param $search, Boolean value whether search is enable or not
		 * @param $limit, Limit of record set
		 * @param $offset, Offset of record set
		 * @param $file , view file
		 * @param $format , format of the out put
		 * @param $collist, to pass the column filter to the view columns are sent as
		 *        col01:col02:...:coln and is pased to view as an array of col names
		 *        (Added by WCD on 31/7/13)
		 * @param $widths to pass the column widths to the view, widths are sent as col1=10:col2=25.... to the controller
		 * 		  controller will pass the width as array to the view
		 * 		  array('col1'=>10,'col2'=>25)
		 * @param $visibilityList, pass the visibility list to the view, list should be sent col1=true:col2=false ... to the controller 
		 * 		  and the contorller will process the param and construct an array as 
		 *        array(col1=>true,col2=>true,col3=>false)) and pass it to the view
	     * @param $cellStyles, pass the cell styles list to the view, list should be sent text-align:center_text-align:center_text-align:left ... to the controller 
	     * 		  and the contorller will process the param and construct an array as 
	     *        array(text-align:center,text-align:center,text-align:center) and pass it to the view
	     *        
		 * Data from view :
		 * Use $_REQUEST
		 * Filed names are like :  filed_name_querymethod
		 *
		 *	Send to Model : Array of data
		 * ex: Array('search' => $searchobj_array,'limit' => $limit,'offset'=>$offset)
		 *
		 * Note : $searchobj_array is a array consist of set of objects.
		 * ex: $searchobj_array = array([0]=>array('search_filed'=>'name','search_text'=>'sara','query_method'=>'like'),[1]=>array('search_filed'=>'country','search_text'=>'srilanka','query_method'=>'equel'))
		 * @return  the data feed
		 * @access	public
	 	 * @since	1.0
		 */
      
	function index(){	
		if(!$this->check_login()){
			$this->login();
		}
		else{
			$wrapper = array();
			$msg = null;
			$action=(($this->input->get('a',true)))?$this->input->get('a',true):null;
			$pid=((!empty($_SESSION['pid'])))?$_SESSION['pid']:null;
			$result = $this->profiles_model->get_data(
				array(
					'search'=>array(array('search_field' => 'pid', 'search_text' => $pid, 'query_method'=>'equal')),
					'limit' => 1, 'offset'=> 0, 'order_by'=>array('profiles.pid'=>'Asc')
				)
			);
			
			if(!empty($result['result_set'])){
				//add - for null fields
				foreach($result['result_set'][1] as $k => $v ){
					if(empty($v)) $result['result_set'][1][$k] = '-';
				}
				$result['result_set'][1]['image_url']	= $result['result_set'][1]['applicant_image'];
				$result['result_set'][1]['cv_url']		= $result['result_set'][1]['cv_path'];
				$result['result_set'][1]['cv_name'] 	= basename($result['result_set'][1]['cv_path']);
				$wrapper['result']	= $result['result_set'];
				$wrapper['msg'][]	= $msg;
				
				if($action=='edit'){
					$wrapper['form_data'] = $result['result_set'][1];
					$this->load->view('edit_profile',$wrapper);
				}
				else{
					$wrapper['other_jobs_arr'] = $this->get_other_jobs_list();
					$this->load->view('profile',$wrapper);
				}
			}
			else{
				$wrapper['result'] = null;
				$wrapper['msg'][] = array('type'=>'error','msg'=>'Profile not found!');
				$this->load->view('profile',$wrapper);
			}//end if
		}//end if
	}//end of index method
	
	
	function edit(){
		$pid = (isset($_GET['pid']))?$_GET['pid']:null;
		$app_data = $this->input->post(null,true);
		$msg = null;
		
		$wrapper['form_data']['pid'] = $pid;
		$wrapper = array();
		$wrapper['app_date'] = date('Y-m-d');
		
		$result = $this->profiles_model->get_data(
			array(
				'search'=>array(array('search_field' => 'pid', 'search_text' => $pid, 'query_method'=>'equal')),
				'limit' => 1, 'offset'=> 0, 'order_by'=>array('profiles.pid'=>'Asc')
			)
		);
		
		$result['result_set'][1]['image_url'] = $result['result_set'][1]['applicant_image'];
		$result['result_set'][1]['cv_url'] = $result['result_set'][1]['cv_path'];
		$result['result_set'][1]['cv_name'] = basename($result['result_set'][1]['cv_path']);
		
		if(!empty($app_data['first_name']) && !empty($app_data['last_name'])){
			//var_dump($app_data);
			// filter form data from unwanted fields
			foreach($app_data as $c=>$v){
				if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
					$app_data[$c] = $v;
				}
			}//end foreach
			//$app_data['image_url'] = $result['result_set'][1]['image_url'];
			//$app_data['cv_url'] = $result['result_set'][1]['cv_url'];
			//$app_data['cv_name'] = $result['result_set'][1]['cv_name'];
			$wrapper['form_data'] = $app_data;
			$this->handle_file_uploads($app_data,$wrapper);
		}else{		
			$wrapper['form_data'] = $result['result_set'][1];
			$wrapper['msg'][] = $msg;
			$this->load->view('edit_profile',$wrapper);
		}
	}//end of function
	
	
	function handle_file_uploads($app_data,$wrapper){
		$error_msg = array();
	
		if(!empty($_FILES["applicant_image"]['name'])){
			$allowed =  array('gif','png' ,'jpg');
			$filename = $_FILES['applicant_image']['name'];
			$ext = pathinfo($filename, PATHINFO_EXTENSION);
				
			if(in_array($ext,$allowed)) {
				$finame_ext = explode('.',$filename);
				// The complete path/filename
				//$filename = '../public/uploads/' . time() . $_SERVER['REMOTE_ADDR'] .'.'. $ext;
				//$_FILES["applicant_image"]['name'] = time() . $_SERVER['REMOTE_ADDR'] .'.'. $ext;
					
				$filename = './public/uploads/' . $app_data['first_name'].'_'. $app_data['last_name']. '.'. $ext;
				$_FILES["applicant_image"]['name'] = $app_data['first_name'].'_'. $app_data['last_name']. '.'. $ext;
					
					
				if (!is_uploaded_file($_FILES['applicant_image']['tmp_name']) or !copy($_FILES['applicant_image']['tmp_name'], $filename)){
						
					$error_msg['applicant_image']['msg'] = "Could not  save file as $filename! -- ".$_FILES['applicant_image']['error'];
					$error_msg['applicant_image']['type'] = "error";
					log_message('error','File upload error: '.$error_msg['applicant_image']['msg']);
				}else{
					$app_data['applicant_image'] = $filename;
				}
			}else{
				$error_msg[] = array('type'=>'error','msg'=>'The image file you have uploaded is incompatible. Please upload a gif,png or jpg image!');
			}
		}//end if
	
		if(!empty($_FILES["cv_file"]['name'])){
			$allowed =  array('pdf','doc' ,'txt','docx');
			$filename = $_FILES['cv_file']['name'];
			$ext = pathinfo($filename, PATHINFO_EXTENSION);
				
			if(in_array($ext,$allowed)) {
				$finame_ext = explode('.',$filename);
				// The complete path/filename
				//$filename = '../public/uploads/' . time() . $_SERVER['REMOTE_ADDR'] .'.'. $ext;
				//$_FILES["applicant_image"]['name'] = time() . $_SERVER['REMOTE_ADDR'] .'.'. $ext;
	
				$filename = "./public/uploads/".$app_data['first_name']."_". $app_data['last_name']."_cv.$ext";
				$_FILES["cv_file"]['name'] = $app_data['first_name']."_". $app_data['last_name']."_cv.$ext";
	
				if (!is_uploaded_file($_FILES['cv_file']['tmp_name']) or !copy($_FILES['cv_file']['tmp_name'], $filename)){
					$error_msg['cv_file']['msg']	= "Could not  save file as $filename! -- Error Code :".$_FILES['cv_file']['error'];
					$error_msg['cv_file']['type']	= "error";
					
					log_message('error','File upload error: '.$error_msg['cv_file']['msg']);
				}else{
					$app_data['cv_path'] = $filename;
				}
			}else{
				$error_msg[] = array('type'=>'error','msg'=> 'The CV you have uploaded is incompatible. Please upload a pdf,doc,docx or txt file!');
			}//end if
		}//endif
		
		if(empty($error_msg)){
			//var_dump($app_data);
			$this->update_profile($app_data,$wrapper);
		}else{
			$wrapper['msg']= $error_msg;			
			$this->load->view('edit_profile',$wrapper);
		}//end if error msg check
	}//end of function
	
	
	function update_profile($app_data,$wrapper){		
		// filter form data from unwanted fields
		foreach($app_data as $c=>$v){
			if($c!='cv_url' && $c!='image_url' && $c !='MAX_FILE_SIZE' && $c != 'cv_name'){
				$app_data[$c] = $v;
			}else{
				unset($app_data[$c]);
			}
		}//end foreach
		
		$this->profiles_model->save($app_data,array('pid' => $app_data['pid']));
		$wrapper['msg'][] = array('type'=>'success' , 'msg'=>'Your profile has been updated successfully!');
		$result = $this->profiles_model->get_data(
			array(
				'search'=>array(array('search_field' => 'pid', 'search_text' => $app_data['pid'], 'query_method'=>'equal')),
				'limit' => 1, 'offset'=> 0, 'order_by'=>array('profiles.pid'=>'Asc')
			)
		);
		
		if(!empty($result['result_set'])){
			$result['result_set'][1]['image_url'] = UPLOADS_FOLDER_PATH.basename($result['result_set'][1]['applicant_image']);
			$result['result_set'][1]['cv_url'] = UPLOADS_FOLDER_PATH.basename($result['result_set'][1]['cv_path']);
			$result['result_set'][1]['cv_name'] = basename($result['result_set'][1]['cv_path']);
						
			//add - for null fields
			foreach($result['result_set'][1] as $k => $v ){
				if(empty($v)) $result['result_set'][1][$k] = '-';
			}
			
			$wrapper['result'] = $result['result_set'];
			header('Location: '.site_url('profiles/?pid='.$app_data['pid']));
			//$this->load->view('profile',$wrapper);
		}//end if
	}//end of function
	
	
	function get_other_jobs_list(){
		// get job vacancy info from staff request
		$result = $this->staff_requests_model->get_data(
			array(
				'search'=>array(array('search_field' => 'hire_status', 'search_text' => 'Hire now', 'query_method'=>'equal')),
				'limit' => 100, 'offset'=> 0, 'order_by'=>array('staff_requests.id'=>'Asc')
			)
		);
		return $result['result_set'];
	}//end of function
	
	
	/**
	 * is_url_exist($url)
	 * 
	 * http://stackoverflow.com/questions/7684771/how-check-if-file-exists-from-the-url
	 * 
	 * @param unknown $url
	 * @return boolean
	 */
	function is_url_exist($url){
		
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_NOBODY, true);
		curl_exec($ch);
		$code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	
		if($code == 200){
			$status = true;
		}else{
			$status = false;
		}
		curl_close($ch);
		return $status;
	}//end of function
	
	
	/**
	 * Function data_form 
	 * 
	 * function handaling form add,edit,delete and view features
	 * 
	 * @param  $data stirng values, key
	 * @param  $mode strign, forms type add, edit, delete, view
	 * @return	
	 * @access	
	 * @since	1.0
	 */
	
	function data_form($mode='add',$data = null){
		$this->log_create->set_otherDetails(array('Mode'=>$mode?$mode:'-','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data:'-')));
		$this->log_create->init();
	
		$data2save = array();
		$key2save = array();
		$message = array('msgText'=>'','msgType'=>'','focusField'=>'');
		
		if($mode != 'add'){
			$limit=0;
			$offset=0;
			$row=$this->job_applications_model->get_data(array(
				'search'=>array(array('search_field' => 'job_applications.id','search_text' => $data,'query_method'=>'equal')),
				'limit' => $limit, 'offset'=>$offset
			));
			$w = $row['result_set'][1]; //should we validate if there is records?
			foreach ($w as $c=>$v){ $wrapper[$c] = $v; }
		}
		
		if($_POST){
			//$postData = $this->input->post();
			$postData = $_POST;
			
			foreach($postData as $c=>$v){
				if($c!='mode' && $c!='formstatus'){
					$data2save[$c] = $v;
				}
				$wrapper[$c] = $v;
			}
			if($this->input->post('id') !=''){
				$key2save = array('id' =>$this->input->post('id'));
			}
		}
		
		switch ($mode){
			case "add": //-----------------------------------------------------
				//Check duplicates
				if ($this->input->post('first_name')) {
					if ($this->job_applications_model->exists(array('first_name' => $this->input->post('first_name')))) {
						$message['msgText'] ='Sorry this record already exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='first_name';
					}else{
						$msg = $this->job_applications_model->save($data2save,$key2save);
						if ($msg) {
							$message['msgText'] ='<span style="color:#008000;">Record successfully created!</span>';
							$message['msgType'] ='success';
							$message['gridHandler'] ='updateAndClose';
						}else{
							$message['msgText'] =$msg;
							$message['msgType'] ='failure';
							$message['focusField'] ='first_name';
						}
					}
				}
			break;
			case "edit":
				//Do validations if form submitted based on POST var
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_applications_model->exists(array('id' => $this->input->post('id')))) {
					 	$message['msgText'] ='Sorry this record does not exist!';
					 	$message['msgType'] ='failure';
					 	$message['focusField'] ='first_name';
					}else{//Valid key
						//checking existance
						if ($this->job_applications_model->exists(array('first_name' => $this->input->post('first_name'),'id !=' => $this->input->post('id')))){
							$message['msgText'] ='Sorry this record already exist!';
							$message['msgType'] ='failure';
							$message['focusField'] ='first_name';
						}
						else{
						    $msg = $this->job_applications_model->save($data2save,$key2save);
							if ($msg) {
								$message['msgText'] ='<span style="color:#008000;">Record successfully updated!</span>';
								$message['msgType'] ='success';
								$message['gridHandler'] ='updateAndClose';
							}
							else{
								$message['msgText'] =$msg;
								$message['msgType'] ='failure';
								$message['focusField'] ='first_name';
							}
						}
				 	}
				 	//end validation & save
				}
			break;
			case "delete":
				//Do validations if form submitted based on POST var
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_applications_model->exists(array('id' => $this->input->post('id')))) {
					 	$message['msgText'] ='Sorry this record does not exist!';
					 	$message['msgType'] ='failure';
					 	$message['focusField'] ='';
					}
				}
			break;
			case "view":
			break;
		}
		
		$wrapper['message'] = $message;
		$wrapper['mode'] = $mode;
		$this->load->view('job_applications_form',$wrapper);
	}
	
	
	function create_profile_page($app_data){
		
		//prepare One Time Password
		$string = 'abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$string_shuffled = str_shuffle($string);
		$password = substr($string_shuffled, 1, 7);
		$app_data['password'] = $password;
		$this->profiles_model->save($app_data,false);
		
		//now send created password via email to applicant
		$subject = "Your profile has been created at Ekwa ";
		$body = "Dear ".$app_data['first_name'].',<br><br>'.
				'Your profile has been created at Ekwa jobs board.<br>
				Your login credentials are as follows,<br><br>'.
				'User id: '.$app_data['email'].'<br>'.
				'Password: '.$password.
				'<br><br>Please login to your profile page and change your password by clicking on following link,<br><br>'.
				'<a href="'.site_url('profiles/index').'">'.site_url('profiles/index').'</a><br><br>'.
				'Thank You,<br>Ekwa Job Board';
				
		$config['mailtype'] = 'html';
		$this->email->initialize($config);
		$this->email->clear();
		$this->email->to(emailcon($app_data['email']));
		$this->email->from(PDA_EMAIL,'Ekwa Marketing');
		/*
		$this->email->to('mrmroshan@yahoo.com');
		$this->email->from('roshan@ekwa.com','Ekwa Marketing');
		$this->email->to('rizla@ekwa.com');//for accuracy monitoriong
		$this->email->bcc('roshan@ekwa.com');//for accuracy monitoriong
		*/
		$this->email->subject($subject);
		$this->email->message($body);
		$this->email->send();
	}//end of function
	
	
	function evaluate_application($app_data){
		//define rules to evaluate app data then check against them
		return true;
	}//end of function
	
	
	function send_mail($type=null){
		
	}//end of function
	    	
		/**
  		 * Function save()
  		 * 
  		 * Data from View
  		 * using $_REQUEST
  		 * Data to model
  		 * send data as a array
  		 * two arrays. One is for data and one is for key.
  		 * ex: data=array('field1'=>'value1','field2'=>'value2'.....);
  		 *     key=array('staff_id'=>123,'project_id'=>534);
  		 *     
  		 * @param   action - add or edit
  		 * @param   callback - callback fun name for field validation
  		 * @return  bool true/false
  		 * @access	
	 	 * @since	2.0
  		 */
	     
  	function save($action,$callback = null){
  		$save_data=array();
  		$key=array();
  		$metadata = $this->job_applications_model->getMetadata();
  		$metadata = explode(",",$metadata['PK']);
  		
  		log_message('info','Save data :-'.serialize($_POST));
  		
  		foreach((count($_POST)>0?$_POST:$_GET) as $k => $v){
  			$end = substr(strrchr($k, "_"), 1);
  			if(in_array($k,$metadata) !== false) {
  				$key[$k] = $v;
  			}elseif($end=='skip') {
  				//nothing do with skip
  			}else {
  				$save_data[$k]=$v;
  			}
  		}
  		
  		// AIR call handling mechanism ============================================================================
  		// if AIR_call_flag is true which means its an AIR related call/external call
  		if($this->AIR_call_flag){
  			if($this->debug)log_message('info',"save() invoked: request method:".$this->AR_Utilities->request_method);

  			//** Implement AIR call variable validation as following example code. Use error codes above 520  			
  			/*  			    
  			if(empty($actual_start_date)){
  				$this->AR_Utilities->header_output(520,'Actual Start Date cannot be empty');
  				exit;
  			}else if(empty($actual_end_date)){
  				$this->AR_Utilities->header_output(521,'Actual End Date cannot be empty');
  				exit;
  			}
  			*/  			  			
  			if($this->AR_Utilities->request_method == 'get'){
  				
  				// usually form submissions are made as post. If your form submits as get then use this 
  				// space to echo output as notmal or use a view file whenever appropriate
  			
  			}else if($this->AR_Utilities->request_method == 'post'){  			
  				$added=$this->job_applications_model->save($save_data,$key);  				
  				$this->log_create->set_otherDetails(array('Mode'=>$action,'AIR call: Data'=>serialize($save_data).", KEY: ".serialize($key)));
  				$this->log_create->init();  				
  				$this->AR_Utilities->header_output(200,$added); // You can customized your success message as you wish  				
  			}	
  			
  			//end if AIR call verifier		
  		}else{  				
			$added=$this->job_applications_model->save($save_data,$key);
			$this->log_create->set_otherDetails(array('Mode'=>$action,'Data'=>serialize($save_data).", KEY: ".serialize($key)));
			$this->log_create->init();  				
			echo $added;  	
  		}
  		//=====================================================================================================================		
	}//end of save method
	    
	
	function update_status($status=null,$id_list=null){
		switch($status){
			case 'shortlistall':
				$ids = explode('-',$id_list);
				foreach($ids as $id){
					if(!empty($id))
					$this->job_applications_model->save(array('status'=>'SHORTLISTED','stat_cng_date'=> date("Y-m-d H:i:s")),array('id'=>$id));
				}
				echo 1;
			break;
			case 'rejectall':
				$ids = explode('-',$id_list);
				foreach($ids as $id){
					if(!empty($id))
						$this->job_applications_model->save(array('status'=>'REJECTED','stat_cng_date'=> date("Y-m-d H:i:s")),array('id'=>$id));
				}
				echo 1;
			break;
			case 'waitlistall':
				$ids = explode('-',$id_list);
				foreach($ids as $id){
					if(!empty($id))
						$this->job_applications_model->save(array('status'=>'WAITLISTED','stat_cng_date'=> date("Y-m-d H:i:s")),array('id'=>$id));
				}
				echo 1;
			break;			
		}
	}//end of function
	    
		/**
		 * Function key_validate()
		 *
		 * This is to validate the keys which are send based on the action param
		 * key=array('staff_id'=>123,'project_id'=>534,'worktype_id'=>342);
		 *
		 * @param $action , add / edit
		 * @param $key , primary $key can be composit or single
		 *
		 * @return true on success or on valid key , on inexistance or invalid key error will be returned as an array
		 * 		ex: array('primary_key'=>'Doesnt exists','staff_id'=>'Doesnt exists')
		 *
		 * @access
		 * @since	2.0
		 */
	
    function key_validate($action,$key) {
    	   
	    //make overall validation true at the begining
	    $overall_valid=true;
	    $error_info=array();
	    
	    /*check for the primary key or composite key exists. Send key array to check.*/
	    $key_exist=$this->job_applications_model->exists($key);
		
	    if($key_exist) {
	      if($action=='add') {
	          //if the primary key exists this can not add. so validation fails and add information 
	          //to error info array.
	          $overall_valid=false;
	          $error_info['primary_key']='Record Already exists';
	      }
	      if($action=='edit') {
	          //in edit function the primary key should be there.
	          //to error info array.
	          $overall_valid=true;
	      }
	    }else {
	      if($action=='add') {
	          //if primary key not found it can be added
	          $overall_valid=true;                   
	      }
	      if($action=='edit') {
	          //if primary key not found it can not be edited         
	          $overall_valid=false;
	          $error_info['primary_key']='Record Doesnt exists';
	      }
	    }
	      
	    if($overall_valid==true){
	        return true;
	    }
	    else  {
	        return $error_info; //array('primary_key'=>'Already exists') or
	                            //array('primary_key'=>'Doesnt exists','staff_id'=>'Doesnt exists')  
	    }
    }
 		
		/**
		 * Function delete()
		 * 
		 * Data from View
		 * using $_REQUEST
		 * $_REQUEST['staff_id']=234
		 *
		 * @param $String, the key 
		 *  
		 * Data to model
		 * send a array
		 * ex: $key = array('staff_id'=>123,'project_id'=>245,'worktype_id'=>933)
		 * 
		 * @return 
	     * @access	
	     * @since	2.0
		 */
     
	function delete($String){
        $delete=array();
        $pieces = explode("-", $String);
		foreach($pieces as $k => $v) {
            $content = explode(":", $v);
            $delete[$content[0]]=$content[1];
        }	

		$this->log_create->set_otherDetails(array('Mode'=>'delete','Data'=>serialize($delete)));
		$this->log_create->init();       		
		return($this->job_applications_model->delete($delete));
	}
 		
  		/**
  		 * Function loadForm()
  		 * 
		 * load the form for creation / edit
		 * 
		 * @param $editable, key, mode info
		 * @param $file , name of the view file
		 * @return 
	     * @access	
	     * @since	2.0
		 */ 

  	function loadForm($editable=null,$file='job_applications_form') {
  		$data['editable'] = $editable;
  		$this->load->view($file,$data);
  	} 
	
		 /**
		  * Function loadWB()
		  * 
		  * function initiates the workbech
		  *
		  * @param $file , name of the view file
		  * @return loads the work bench
	      * @access	
	      * @since	2.0
		  */
		  
 	function loadWB($file='job_applications_wb'){
 		$data ='';
  		$this->load->view($file,$data);
  	}

  
	    /**
 		 * Function createDropdown()
 		 *
 		 * 
 		 * Function overview :-
 		 * createDropdown is the component function. 
 		 * Its main functionality is to produce a dropdown with pre populated table data
 		 *
 		 * Parameter list :-
 		 *
 		 *   $data['displayClm']     => 'field1'  - preselection of column to be displayed         //sachini
 		 *   $data['selectByValue']  => null      - preselection of list items by value
 		 *   $data['selectBYText']   => null      - preselection of list items by Text
 		 *   $data['filterBy']       => null      - filter data set by a field or list
 		 *   $data['outFormat']      => 'html'    - Format of the output like HTML,XML Etc
 		 *   $data['isMultiple']     => false     - is the drop down with multi select capable
 		 *   $data['sort']           => 'asc'     - sort list text Ascending or Descending
 		 *   $data['optionsOnly']    => false     - Specify the controller that output only <options> values
 		 *   $data['groupBy']        => null      - Display the dropdown grouped according to the specified column        //sachini
 		 *   $data['nameTag']        => 'field2'  - Name and Id values of the select tag                                 //sachini
 		 *
 		 *
 		 *    Usage :-
 		 *
 		 *    1) Format for internal functional call by passing data array
 		 *
 		 *    $data = array('selectByValue' => null,
 		 *					'selectBYText' => null,
 		 *					'outFormat' => 'html' ,
 		 *					'isMultiple' => false,
 		 *					'sort' => 'asc',
 		 *					'optionsOnly' => false,
 		 *					'filterBy' => array(
 		 *									'search_field' => 'T.status',
 		 *									'search_text' => '0',
 		 *									'query_method'=>'equal',
 		 *									'order_by' => 'asc'
 		 *									)
 		 *						)
 		 *
 		 *
 		 *    2) Format of external call by URL
 		 *
 		 *    http://.../index.php/Job_applications/createDropdown/?sbv=null&sbt=null&format=html&multiple=false&sort=asc&filterby=status_equal=1
 		 *
 		 *
 		 *    1. For normal listing:
 		 *
 		 *    http://.../index.php/Job_applications/createDropdown
 		 *
 		 *    2. For listing with multiple selection
 		 *
 		 *    http://.../index.php/Job_applications/createDropdown/?multiple=true
 		 *
 		 *    3. For listing with pre selection (select by value) for single selection drop down
 		 *
 		 *    http://.../index.php/Job_applications/createDropdown/?sbv=123
 		 *
 		 *    4. For listing with pre selection for multiple (select by value)
 		 *
 		 *    http://.../index.php/Job_applications/createDropdown/?sbv=123,321,345&multiple=true
 		 *
 		 *    5. For listing with pre selection of select by text for single selection dropdown
 		 *
 		 *     http://.../index.php/Job_applications/createDropdown/?sbt=test string&multiple=true
 		 *
 		 *    6. For xml(DHTMLX compatible) dropdown
 		 *
 		 *    http://.../index.php/Job_applications/createDropdown/?format=xml
 		 *
 		 *    7. groupBy
 		 *    http://...../Job_applications/createDropdown/?groupby=users.user_type
 		 *
 		 *	 8. groupCode
 		 *	  http://..../Job_applications/createDropdown/?groupby=users.user_type&groupcodes=1=Staff,2=Admin,4=Manager
 		 *
 		 *    Description of parameter list,
 		 *
 		 *    sbv - selectByValue  => null
 		 *    sbt - selectBYText   => null
 		 *    format - outFormat   => 'html'
 		 *    multiple - isMultiple=> false
 		 *    sort - sort          => 'asc'
 		 *    filterby - filterBy  => null
 		 *    optionsOnly - options only listing
 		 *
 		 *    groupBy - column to group, should be specified with the table name ex: job_applications.staff_id
 		 *
 		 *	  groupcodes - coma seperated values to display as group lable
 		 *
		 * @param $data , data array
		 *  
		 * @access public
		 * @return returns the table dropdown
		 * @since 1.0
 		 */

	public function createDropdown($data = false){
  
	  	$dataset = null;
	  	$selectByValue = null;
	  	$selectBYText = null;
	  	$outFormat = 'html' ;
	  	$isMultiple = null;
	  	$sort = null;
	    $sort_array = array('job_applications.id' => 'ASC');
	  	$filterBy = null;
	   	$searchobj_array = null;
	   	$optionsOnly = false;
	   	$label = null;
	   	$displayClm = 'job_applications.first_name';
	   	$groupBy = null;   
	   	$groupcodes = null;
	   	$nameTag = 'id'; 
	  	
		  	/**
		  	 *	first check whether the call is internal(ie:internal function call) or external(ie:url call)
		  	 *	to do this we can check $data variable.if this variable is an array it means its an internal call
		  	 *	if $data is 'false' it means its an external call.
		  	 */	
	  		
	  	if(is_array($data)){
	  		
	  		/** 
	  		 * this is an internal call. so construct the search obj with passed array parameeters. 
	  		 * extract the data and pass on to the view
	  		 */
	  		$selectByValue = isset($data['selectByValue'])?$data['selectByValue']:null;
	  		$selectBYText = isset($data['selectBYText'])?$data['selectBYText']:null;
	  		$outFormat = isset($data['outFormat'])?$data['outFormat']:null;
	  		$isMultiple = isset($data['isMultiple'])?$data['isMultiple']:false;
	  		$sort = isset($data['sort'])?$data['sort']:'job_applications.id=ASC';
	  		$filterBy = isset($data['filterBy'])?$data['filterBy']:null;
	  		$optionsOnly = isset($data['optionsOnly'])?$data['optionsOnly']:false;
	  		
	  		$label = isset($data['label'])?$data['label']:'id';
	  		$displayClm = isset($data['display'])?$data['display']:$displayClm;
	  		$groupBy = isset($data['groupBy'])?$data['groupBy']:null;    
	  		$nameTag = isset($data['nameTag'])?$data['nameTag']:'id';    
	  		$groupcodes = isset($data['groupcodes'])?$data['groupcodes']:null;
	  	}else{
	  		
	  		/** 
	  		 * this is an external url call. So process $_GET or $_POST parameeter values and using
	  		 * these values construct search obj and fetch data for combo box
	  		 */
	  		if(count($_POST)>0 || count($_GET)>0){
	  			
	        	$myParams = count($_POST)>0? $_POST:$_GET;
	  
	  			$selectByValue = isset($myParams['sbv'])? $myParams['sbv']:null ;		
	  			$selectByValue = (!empty($selectByValue))?$selectByValue:null; // set default values if not supplied.
	  			 		
	  			$selectBYText = isset($myParams['sbt'])?$myParams['sbt']:null;
	  			$selectBYText = (!empty($selectBYText))?$selectBYText:null;
	  			
	  			$outFormat = isset($myParams['format'])?$myParams['format']:null;
	  			$outFormat = ($outFormat != 'html' && !empty($outFormat))?$outFormat:'html';
	  			
	  			$isMultiple = isset($myParams['multiple'])?$myParams['multiple']:null;
	  			$isMultiple = ($isMultiple == 'true')?true:false;
	  			
	  			$sort = isset($myParams['sort'])?$myParams['sort']:'job_applications.id=ASC';
	  			
	  			$filterBy_string = isset($myParams['filterby'])? $myParams['filterby']:null;
	  			$filterBy_string = (!empty($filterBy_string))?$filterBy_string:null;
	  			
	  			$optionsOnly = isset($myParams['optionsonly'])? $myParams['optionsonly']:false;
	  			$optionsOnly = ($optionsOnly == 'true')? true:false;
	  
	  			$label = isset($myParams['label'])?$myParams['label']:null;
	  			$label = (!empty($label))?$label:null;
	  			
	  			$displayClm = isset($myParams['display'])? $myParams['display']:$displayClm;
	  			$displayClm = (!empty($displayClm))?$displayClm:'description';
	  			
	  			$groupBy = isset($myParams['groupby'])?$myParams['groupby']:null;    
	  			$groupBy = (!empty($groupBy))?$groupBy:null;                         
	  			
	  			$groupcodes = isset($myParams['groupcodes'])?$myParams['groupcodes']:null;
	  			
	  			/**
	  			 *	first check whether the request includes grouping
	  			 *	to do this we can check $groupBy variable.if this variable is null then it is ungrouped dropdown
	  			 *	if $groupBy is 'field1' it means its a request for grouped dropdown.
	  			 */
	  			
	  			if($groupBy){
	  				/**
	  				 * this is a grouped dropdown request
	  				 * set the $sort_array first sorted according to $groupBy column and then to $displayClm
	  				 */
	  				$sort_array = array($groupBy => 'ASC',$displayClm => 'ASC' );
	  				if (!empty($groupcodes)){
	  			
	  					$sortPara = explode(',',$groupcodes);
	  					foreach ($sortPara as $val ){
	  						$split =  explode('=',$val);
	  						$group[$split[0]]= $split[1];
	  					}
	  				}
	  			}else{
	  				
	  				/**
	  				 * this is not a grouped dropdown request
	  				 */
	  				$sort = isset($myParams['sort'])?$myParams['sort']:"$displayClm=ASC";
	  			}
	  			//end of sort allocation condition
	  			$nameTag = isset($myParams['nametag'])?$myParams['nametag']:$nameTag;   
	  			$nameTag = (!empty($nameTag))?$nameTag:'id';                       
	  			
	  			if(!empty($filterBy_string)){        
	  				$fieldPara = explode(',',$filterBy_string);
	          		foreach ($fieldPara as $val )   {
	             			$split =  explode('=',$val);
	             			$filterBy[$split[0]]= $split[1];
          			}
	  			}else{
	  				$filterBy = null;
	  			}
	        if (!empty($sort)){
	             
	          $sortPara = explode(',',$sort);
	          foreach ($sortPara as $val )   {
	             $split =  explode('=',$val);
	             $sort_array[$split[0]]= $split[1];
	          }
	        }
	  			
	  		}
	  	}//end of param check and config
	  
	  	// Construct search object if present 
	  		
	  	If ($filterBy){
	  		$searchobj_array = array();
	  		foreach($filterBy as $key => $val){
	  	
	  			$search_text = $val; //search text
	  			$query_method = substr(strrchr($key, "_"), 1);
	  			$pos = strrpos($key, '_');
	  			$field = substr($key, 0, $pos);
	  			$search_obj = array(
	  					'search_field' => $field,
	  					'search_text'  => $search_text,
	  					'query_method' => $query_method
	  			);
	  			array_push($searchobj_array, $search_obj);
	  		}	
	  	}//end if
	    
	      //Construct selection list. (Fixed)
	      $selection = 'job_applications.id,job_applications.first_name,job_applications.last_name,job_applications.initials,job_applications.other_names,job_applications.address,job_applications.email,job_applications.land_phone,job_applications.mobile_phone,job_applications.primary_education_at,job_applications.primary_edu_qualy,job_applications.secondary_edu_at,job_applications.secondary_edu_qual,job_applications.professional_edu_at,job_applications.professional_edu_qual,job_applications.other_qual,job_applications.work_exp,job_applications.reason_4_leave,job_applications.cv,job_applications.have_adsl,job_applications.can_wok_min,job_applications.wfh_ok,job_applications.cv_path,job_applications.answer_path,job_applications.unsigned_offer_path,job_applications.signed_offer_path,job_applications.remarks,job_applications.status,job_applications.country,job_applications.post_id,job_applications.request_id,job_applications.app_date,job_applications.referrer_id,job_applications.title,job_applications.gender,job_applications.currency,job_applications.has_other_job,job_applications.other_job_des,job_applications.is_studying,job_applications.study_details,job_applications.canwork_8hrs,job_applications.cantwork_8hrs,job_applications.room2work,job_applications.minsalexp,job_applications.whyhire,job_applications.nic_pp_no,job_applications.date_of_birth,job_applications.civil_status,job_applications.has_own_computer,job_applications.plan2getadsl,job_applications.why_wfh,job_applications.test_time_a,job_applications.test_time_b,job_applications.how_u_heard,job_applications.extr_refs,job_applications.verified,job_applications.stat_cng_date,job_applications.offer_letter_tpl,job_applications.offer_letter_with_appdetails,job_applications.sent_offer_letter,job_applications.signed_offer_letter';
	    
	      // Fetch data from model
	  	  $dataset = $this->job_applications_model->get_data(array(
	  			'search' => $searchobj_array,
	  	  		'limit' => 0,
	  	  		'offset'=>0,
	  			'selection' => $selection,
	        		'order_by' => $sort_array));  
	  	
	  	// Construct data structure for view
	  	$wrapped_data['data']['dataset'] = $dataset;	
	    $wrapped_data['selectByValue'] = $selectByValue;
	  	$wrapped_data['selectByText'] = $selectBYText;
	  	$wrapped_data['outFormat'] = $outFormat;
	  	$wrapped_data['isMultiple'] = $isMultiple;
	  	$wrapped_data['required'] = true;
		$wrapped_data['label'] = $label;
		
		$displayClm =  explode('.',$displayClm);
		$wrapped_data['display'] = $displayClm[1];
		$wrapped_data['nameTag'] = $nameTag;
	  	
	  	if($optionsOnly !=""){
	  		$wrapped_data['optionsOnly'] = $optionsOnly;
	  	}
	  	
	  	if($groupBy != ""){
	  		$gb_arrya=explode(",",$groupBy);
	  		for($x=0;$x<count($gb_arrya); $x++){
	  			$gb = explode(".",$gb_arrya[$x]);
	  			$wrapped_data['groupBy'] = $gb[1];
	  		}    
	  	}
	  	   
	  	if(!empty($group)){
	  		$wrapped_data['codename'] = $group;
	  	}
	  	
	  	//If AIR_call_flag is true which means its an AIR related call/external call=========================
	  	if($this->AIR_call_flag){
	  		// if the function call is from an external app then identify request method then
	  		// choose appropriate output mechanism.
	  		 
	  		if($this->debug) log_message('info',"createDropdown invoked via AIR call: QUERY- STRING :".count($_POST)>0?serialize($_POST):serialize($_GET));	  			
	  		//perform the function codes and call view file with output.
	  		if($this->AR_Utilities->request_method == 'get'){	  	
	  			$this->load->view('dropdown_template',$wrapped_data);	  	
	  		}else if($this->AR_Utilities->request_method == 'post'){	  	
	  			//If request method is post then use appropriate view files to output as post
	  			//...	  	
	  		}//end if method verifier	  	
	  	}else{	  	
	  		// if the function call is from application itself then proceed with normal output.	  		
	  		// load view file with assigned data array
	  		$this->load->view('dropdown_template',$wrapped_data);	  		
	  	}//end if air call validator	  	
	  	//End of AIR mechanism ==============================================================================	  	
	  		  	
    }// End of Function createDropdown
}//-------- END CLASS -------------------------------------------------------
?>
