<?php
/**
 * Single line Summary of the script file
 *
 *
 * @package			HRM\view\dashboard_view
 * @version			3.0
 * @since			3.0 
 * @copyright		2017 - 2017, BizyCorp Internal Systems Development
 * @license			private, All rights reserved
 * @author			Nuwan Wickramarathne
 * 
 */
 
 if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
/**
 * Single line Summary of the script file
 *
 *
 * Multiline detail description of the file goes here. you may 
 * give any type of details here such as usage and examples
 *
 * @package			HRM\view\dashboard_view
 * @version			3.0
 * @since			3.0
 * @copyright		2017 - 2017, BizyCorp Internal Systems Development
 * @license			private, All rights reserved
 * @author			Nuwan Wickramarathne
 * @uses				
 * @see				
 * @created			Mar 17, 2017 by Nuwan Wickramarathne
 * @modified		Mar 17, 2017 by Nuwan Wickramarathne
 * @modification	
 * 
 */
class dashboard_view{
	// Just a dummy clas for phpdoc to catch the doc header.
}

if(isset($_SESSION['user_name'])){ 
	$user_name = $_SESSION["user_name"];
	$user_type = $_SESSION["user_type"];
}else{
	$user_name = '';
	$user_type = '';	
}

$log_create = new log_object();
$log_create->set_disable($this->config->item('log_status'));
$log_create->set_userDetails($user_name, $user_type);
$log_create->set_otherDetails(array('Mode'=>'dashboard_view','Data'=>'-'));
$log_create->init();
?>

<!-- core CSS -->
<link href="<?=base_url()?>public/css/bootstrap.min.css" rel="stylesheet" />
<link href="<?=base_url()?>public/css/material-dashboard.css" rel="stylesheet" />
<link href="<?=base_url()?>public/css/dashboard.css" rel="stylesheet" />

<!-- Fonts and icons -->
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<link rel="stylesheet" type="text/css" href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700|Material+Icons" />
<link href="http://fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,400,300,600,700" rel="stylesheet">
<link href="http://fonts.googleapis.com/css?family=Lato:300,400,700,300italic,400italic,700italic" rel="stylesheet">

<!-- Core JS Files -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<style>
<!--
.card-header{ margin-top: -20px !important; color: white !important; }
.card-header .title{ color: white; font-weight: bold; }
h3.title{ margin-top: 0px !important; }
h4.title{ margin-top: 0px !important; }
.table-responsive{ overflow-y: auto; height: 280px; }
-->
</style>
<div id="divBench" style="width:98%;height:98%;">
	<br/>
	<div class="row">
		<div class="col-xs-3">
			<div class="card card-stats">
				<div class="card-header" data-background-color="orange">
					<i class="material-icons">content_copy</i>
				</div>
				<div class="card-content">
					<p class="category">New apps</p>
					<h3 class="title"><?=$new_apps?></h3>
				</div>
			</div>
		</div>
		
		<div class="col-xs-3">
			<div class="card card-stats">
				<div class="card-header" data-background-color="green">
					<i class="fa fa-sort-amount-desc"></i>
				</div>
				<div class="card-content">
					<p class="category">Shortlisted</p>
					<h3 class="title"><?=$shortlisted?></h3>
				</div>
			</div>
		</div>
		
		<div class="col-xs-3">
			<div class="card card-stats">
				<div class="card-header" data-background-color="red">
					<i class="fa fa-address-card-o"></i>
				</div>
				<div class="card-content">
					<p class="category">Interview end</p>
					<h3 class="title"><?=$interview_end?></h3>
				</div>
			</div>
		</div>
		
		<div class="col-xs-3">
			<div class="card card-stats">
				<div class="card-header" data-background-color="blue">
					<i class="fa fa-user-plus"></i>
				</div>
				<div class="card-content">
					<p class="category">Hire pending</p>
					<h3 class="title"><?=$hire_pending?></h3>
				</div>
			</div>
		</div>
	</div>
	<br/><br/>
	
	<div class="row">
		<div class="col-xs-6">
			<div class="card">
				<div class="card-header" data-background-color="orange">
					<h4 class="title">Scheduled Interviews for the day</h4>
					<p class="category"><?=date("l jS \of F Y")?></p>
				</div>
				<div class="card-content table-responsive">
					<table class="table table-hover">
						<thead class="text-warning"><tr><th>Applicant Name</th><th>Schedule Time</th></tr></thead>
						<tbody>
							<? if(count($interview)>0){
									foreach ($interview as $key=>$value){
										echo "<tr><td>";
										echo $value['first_name']." ".$value['last_name'];
										echo "</td><td>";
										echo $value['scheduled_datetime'];
										echo "</td></tr>";
									}
								}
								else{ echo "<tr><td colspan=2> No Scheduled Interviews for Today</td></tr>"; }
							?>
						</tbody>
					</table>
				</div>
			</div>
		</div>
		
		<div class="col-xs-6">
			<div class="card">
				<div class="card-header" data-background-color="orange">
					<h4 class="title">Scheduled Tests for the day</h4>
					<p class="category"><?=date("l jS \of F Y")?></p>
				</div>
				<div class="card-content table-responsive">
					<table class="table table-hover">
						<thead class="text-warning"><tr><th>Applicant Name</th><th>Schedule Time</th></tr></thead>
						<tbody>
							<? if(count($test)>0){
									foreach ($test as $key=>$value){
										echo "<tr><td>";
										echo $value['first_name']." ".$value['last_name'];
										echo "</td><td>";
										echo $value['scheduled_datetime'];
										echo "</td></tr>";
									}
								}
								else{ echo "<tr><td colspan=2> No Scheduled Tests for Today</td></tr>"; }
							?>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>
